/*  -*- Mode: C -*- 
 * This file is part of xnetmaj
 * 
 * msg.c -- 
 * 
 * $Id: msg.c,v 1.1 1995/04/23 01:32:45 ksr Exp ksr $
 * Author          : NBC02365@niftyserve.or.jp
 * Created On      : Tue Apr 11 11:13:41 1995
 * Last Modified By: NBC02365@niftyserve.or.jp
 * Last Modified On: Thu Jan 25 22:50:17 1996
 *
 *  Copyright (C) 1995,1996 Todo Software All rights reserved
 */

#include "xnet.h"
#include "xnetmaj.h"
#include "pixread.h"

extern integer_t xwidth, xheight;
extern global_t *game_global;
extern global_t *hora_global;

#define WAIT 0
integer_t speed = WAIT;

static struct
  {
    integer_t tick;
    widget_t p;			/* parent */
    widget_t f;			/* frame */
    widget_t m;			/* msg */
  }
comm[4], decl[4], playframe;

#include "bitmap/misc/tting.xpm"
#include "bitmap/misc/failconn.xpm"
#include "bitmap/misc/connect.xpm"
#include "bitmap/misc/disconne.xpm"
#include "bitmap/misc/msgtumo.xpm"
#include "bitmap/misc/msgron.xpm"
#include "bitmap/misc/msgreach.xpm"

struct gpixmap2 pm_msgconnectting;
struct gpixmap2 pm_msgfailconnect;
struct gpixmap2 pm_msgconnect;
struct gpixmap2 pm_msgdisconnect;
struct gpixmap2 pm_msgtumo;
struct gpixmap2 pm_msgron;
struct gpixmap2 pm_msgreach;

static void
playmessage_clear ()
{
  widget_xunmap (playframe.f);
  widget_flush (playframe.p);
}

void
message_unmap ()
{
  int i;
  for (i = 0; i < 4; i++)
    {
      widget_xunmap (comm[i].f);
    }
  for (i = 0; i < 4; i++)
    {
      widget_xunmap (decl[i].f);
    }
  widget_xunmap (playframe.f);
}
void
message_init (r, msg)
     widget_t r[4], msg[4];
{
  integer_t i;
  widget_t frame;

  read_pix (tting, pm_msgconnectting);
  read_pix (failconn, pm_msgfailconnect);
  read_pix (connect, pm_msgconnect);
  read_pix (disconne, pm_msgdisconnect);
  read_pix (msgtumo, pm_msgtumo);
  read_pix (msgtumo, pm_msgtumo);
  read_pix (msgron, pm_msgron);
  read_pix (msgreach, pm_msgreach);

  for (i = 0; i < 4; i++)
    {
      comm[i].p = r[i];
      if (i == 3)
	{
	  comm[i].f = widget_create ("frame", r[i]);
	}
      else
	{
	  comm[i].f = widget_create ("frame", msg[i]);
	}
      widget_configure (comm[i].f, resource_border_width, 2);
      widget_configure (comm[i].f, resource_relief, relief_frame);
      comm[i].m = widget_create ("text", comm[i].f);
      widget_configure (comm[i].m, resource_border_width, 2);
      widget_configure (comm[i].m, resource_relief, relief_frame);
      widget_set_geometry (comm[i].f, name_width - 4, MSG_H + 4);
      widget_set_geometry (comm[i].m, name_width - 8, MSG_H);

      decl[i].p = r[i];
      decl[i].f = widget_create ("frame", r[i]);
      widget_configure (decl[i].f, resource_border_width, 2);
      widget_configure (decl[i].f, resource_relief, relief_frame);
      decl[i].m = widget_create ("pmcontainer", decl[i].f);
      widget_set_geometry (decl[i].f, name_width - 4, MSG_H + 4);
      widget_set_geometry (decl[i].m, name_width - 8, MSG_H);
      widget_pack (decl[i].f);
      widget_pack (comm[i].f);
      {
	extern integer_t yellowgreen, yellow, tann, white, gray, black;
	widget_set_color_change (decl[i].f, tann, tann, tann, tann);
	widget_set_color_change (comm[i].f, tann, tann, tann, tann);
	/*     widget_set_color_change (decl[i].m, white, white, white, white);   */
	/*     widget_set_color_change (comm[i].m, gray, gray, gray, gray);   */
	widget_configure (decl[i].f, resource_cannot_change_model, 1);
/*      widget_configure(decl[i].m, resource_cannot_change_model, 1);   */
	widget_configure (comm[i].f, resource_cannot_change_model, 1);
/*      widget_configure(comm[i].m, resource_cannot_change_model, 1);  */

	widget_configure (decl[i].m, resource_textcolor, white);
	widget_configure (comm[i].m, resource_textcolor, white);
      }
    }

  playframe.p = r[0];
  playframe.f = widget_create ("frame", r[0]);
  widget_configure (playframe.f, resource_border_width, 2);
  playframe.m = widget_create ("pmcontainer", playframe.f);
  widget_set_geometry (playframe.f, 94, MSG_H + 4);
  widget_set_geometry (playframe.m, 90, MSG_H);
  widget_pack (playframe.f);
  {
    int i;
    for (i = 0; i < 4; i++)
      {
	widget_configure (comm[i].f, resource_packed, 0);
      }
    for (i = 0; i < 4; i++)
      {
	widget_configure (decl[i].f, resource_packed, 0);
      }
    widget_configure (playframe.f, resource_packed, 0);
  }

}


void
msg_tick ()
{
  int i;
  for (i = 0; i < 4; i++)
    {
      if (widget_map_p (comm[i].f))
	{
	  comm[i].tick++;
	  if (comm[i].tick > flag_talktick)
	    {
	      comm[i].tick = 0;
	      widget_xunmap (comm[i].f);
	      widget_flush (comm[i].p);
	    }
	}
    }
}

void
msg_bg_init ()
{
  stop_timer ();
  set_timer_handler ((void *) msg_tick, 2);
}

void
msg_bg_done ()
{
  stop_timer ();
}


static void
popup_playmessage (pm)
     gpixmap2_t pm;
{
  if (!widget_map_p (playframe.p))
    {
      return;
    }
  pmcontainer_print (playframe.m, (*pm));
  widget_map (playframe.f);
  widget_display (playframe.f);
  widget_flush (playframe.f);
  sleep (speed + 2);
  playmessage_clear ();
}

static void
popup_declmessage (i, pm, timeout)
     gpixmap2_t pm;
{
  if (!widget_map_p (decl[i].p))
    {
      return;
    }
  pmcontainer_print (decl[i].m, (*pm));
  widget_map (decl[i].f);
  widget_display (decl[i].f);
  widget_flush (decl[i].f);
  sleep (timeout + 2);
  widget_xunmap (decl[i].f);
  widget_flush (decl[i].p);
}

static void
popup_commmessage (i, str, timeout)
     char *str;
{
  integer_t len;
  integer_t width;

  if (!widget_map_p (comm[i].p))
    {
      return;
    }
  if (widget_map_p (comm[i].f))
    {
      widget_xunmap (comm[i].f);
      widget_flush (comm[i].p);
    }
  if (!flag_talk)
    {
      return;
    }
  comm[i].tick = 0;
  width = text_string_n_pixels (comm[i].m, str, len = strlen (str));
  widget_set_geometry (comm[i].f, width + 4, MSG_H + 4);
  widget_set_geometry (comm[i].m, width, MSG_H);
  widget_configure (comm[i].m, resource_text, str);
  widget_configure (comm[i].m, resource_textfont, SMALLJP);

  widget_map (comm[i].f);
  widget_display (comm[i].f);
  widget_flush (comm[i].f);
}

static void
undisplay_commmessage ()
{
  int i;
  for (i = 0; i < 4; i++)
    {
      if (widget_map_p (comm[i].f))
	{
	  widget_xunmap (comm[i].f);
	  widget_flush (comm[i].p);
	}
    }
}

ui_message_fail_connect ()
{
  extern widget_t root_widget;
  if (widget_eventsqueued (root_widget))
    {
      widget_display (root_widget);
      widget_flush (root_widget);
    }
  popup_playmessage (&pm_msgfailconnect);
}

ui_message_connecting ()
{
  extern widget_t root_widget;
  if (widget_eventsqueued (root_widget))
    {
      widget_display (root_widget);
      widget_flush (root_widget);
    }
  popup_playmessage (&pm_msgconnectting);
}

ui_message_connect ()
{
  popup_playmessage (&pm_msgconnect);
}

ui_message_disconnect ()
{
  popup_playmessage (&pm_msgdisconnect);
}

ui_message_reach (i)
{
  snd (audioplay_declreach ());
  i = pos2who (i);
  popup_declmessage (mytblpos (i), &pm_msgreach, 2 + speed);
}

integer_t flag_pause;
void
wait4key ()
{
  widget_unmap (about_button);
  widget_unmap (flush_button);
  widget_unmap (visible_button);

  widget_configure (cancel_button, resource_text, "click me");
  widget_map (cancel_button);
  widget_display (cancel_button);
  widget_flush (cancel_button);
  wait_key ();
  widget_configure (cancel_button, resource_text, "cancel");
  widget_unmap (cancel_button);
}

void
stop_config ()
{
  char *p;
  integer_t color;
  extern integer_t yellow, white;
  if (!stop_button)
    return;
  if (flag_pause == 0)
    {
      color = white;
      p = "no pause";
    }
  else
    {
      color = yellow;
      p = "pause";
    }

  widget_configure (stop_button, resource_textcolor, color);
  widget_configure (stop_button, resource_text, p);

}

void
stop_button_callback ()
{
  flag_pause = !flag_pause;
  stop_config ();
}


ui_message_tumo (i)
{
  snd (audioplay_decltumo ());
  i = pos2who (i);
  popup_declmessage (mytblpos (i), &pm_msgtumo, 2 + speed);
  flag_not_needredraw = 1;
}

ui_message_ron (i)
{
  snd (audioplay_declron ());
  i = pos2who (i);
  popup_declmessage (mytblpos (i), &pm_msgron, 2 + speed);
  flag_not_needredraw = 1;
}

ui_message_player (gp)
     global_t *gp;
{
  flag_not_needdraw_hand = 1;
}

ui_message_play (gp)
     global_t *gp;
{
/*  flag_not_needredraw = 1; */
}

void
speed_config ()
{
  extern integer_t white, yellow;
  extern integer_t flag_pause;
  char buf[64];
  if (!speed_button)
    {
      return;
    }
#if X11
  if (speed == STOPVALUE)
    {
      sprintf (buf, "wait");
      flag_pause = 1;
      widget_configure (speed_button, resource_textcolor, yellow);
    }
  else
    {
      sprintf (buf, "speed %d", speed + 1);
      flag_pause = 0;
      widget_configure (speed_button, resource_textcolor, white);
    }
#else
  {
    sprintf (buf, "speed %d", flag_gamespeed + 1);
    widget_configure (speed_button, resource_textcolor, white);
  }
#endif
  widget_configure (speed_button, resource_text, buf);
  widget_display (speed_button);
  widget_flush (speed_button);
}

#if X11
void
speed_callback ()
{
  speed++;
  if (speed == 4)
    {
      speed = STOPVALUE;
    }
  flag_pause = (speed == STOPVALUE);
  speed_config ();
}
#else
void
speed_callback ()
{
  flag_gamespeed++;
  if (flag_gamespeed == 9)
    {
      flag_gamespeed = 0;
    }
  speed_config ();
}
#endif

extern integer_t yellow, black, white;
/* from player */
comment (from, i, body)
     int from, i;
     char *body;
{
  char msgbuffer[256];
  char execbuffer[256];

  comment_divide (body, msgbuffer, execbuffer);
  comment_exec_command (execbuffer);

  from = pos2who (from);
  popup_commmessage (mytblpos (from), msgbuffer, 2 + speed);
}

static char *
replacecntl (s)
     char *s;
{
  char *org = s;
  while (*s)
    {
      if (0 < (*s) && (*s) < ' ')
	{
	  *s = ' ';
	}
      s++;
    }
  return org;
}
advice_policy ()
{
  popup_commmessage (3, replacecntl (analize_message (game_global)), 2 + speed);
}

/* from server */
popup (msg, i)
     char *msg;
{
  ;
}

void send_play_message_callback callbackarg_param
{
  widget_configure (w, resource_textcolor, yellow);
  widget_configure (w, resource_border_width, 2);
  widget_configure (w, resource_relief, relief_sunken);
  widget_display (w);
  widget_flush (w);

  msgTalk (game_global, widget_get_text ((void *) w));
  sleep (speed + 2);

  widget_configure (w, resource_textcolor, white);
  widget_configure (w, resource_border_width, 0);
  widget_configure (w, resource_relief, 0);
  widget_display (w);
  widget_flush (w);
}




void
sound_config ()
{
  extern integer_t white, yellow;
  char *s;
  int color;

  if (!sound_button)
    {
      return;
    }
  s = (flag_soundp) ? "sound on" : "silent";
  color = (flag_soundp) ? yellow : white;
  widget_configure (sound_button, resource_textcolor, color);
  widget_configure (sound_button, resource_text, s);
  widget_display (sound_button);
  widget_flush (sound_button);
}

void
sound_button_callback callbackarg_param
{
  flag_soundp = !flag_soundp;
  sound_config ();
}
